# Generating test system with qsys-generate

# Parameters
set QUARTUS_VERSION "$(TOOL_VER)"
set PKG_VERSION "$(TOOL_VER)"
set SYSTEM_NAME "$(CPU_NAME)"
set SYSTEM_EXT ".qsys"
set CPU_SELECTION "$(CPU_SELECTION)"
set CPU_IMPLEMENTATION "$(CPU_IMPLEMENTATION)"
set DEVICE               "$(DEVICE)"
set FAMILY               "$(FAMILY)"
set JTAG_MODULE_ENABLE   "$(JTAG_MODULE_ENABLE)" 	
set BREAKPOINT_ON_HREset "$(BREAKPOINT_ON_HREset)"
set HARDWARE_MDU         "$(HARDWARE_MDU)" 
set USE_HW_MUL "$(USE_HW_MUL)"
set USE_HW_MUL_SETTING "$(USE_HW_MUL_SETTING)"
set OMITS_MSW "$(OMITS_MSW)"
set USE_HW_MUL_IMPL "$(USE_HW_MUL_IMPL)"
set USE_DIV "$(USE_DIV)"
set USE_DCACHE "$(USE_DCACHE)"
# set USE_DCACHE "1" -- for debug
set USE_ICACHE "$(USE_ICACHE)"
set DCACHE_SIZE "$(DCACHE_SIZE)"
set ICACHE_SIZE "$(ICACHE_SIZE)"
set USE_SHIFT_IMPL "$(USE_SHIFT_IMPL)";

set qsys_file_name ""
append qsys_file_name $SYSTEM_NAME $SYSTEM_EXT
package require -exact qsys "$(TOOL_VER)"
set work_dir "$(WORKING_FOLDER)"
set qsys_file_fullname ""
append qsys_file_fullname $work_dir "/" $qsys_file_name

puts "*************** Work dir ****************************"
puts "Work directoru 			is: $work_dir"
puts "*************** System file name ********************"
puts "Qsys file name 			is: $qsys_file_name"
puts "QSYS file full name		is: $qsys_file_fullname" 
puts "----------------------08"
# --- Nios II selection
if { $CPU_IMPLEMENTATION =="tiny" } {
	set cpu_impl "Tiny"
} elseif { $CPU_IMPLEMENTATION =="fast" } {
	set cpu_impl "Fast"
} else {
	#set cpu_impl "Small"
	set cpu_impl "Fast"
}

cd	$work_dir


#close $outfl

puts "*************************************************************************"
puts "*************** create_system nios2_qsys_system *************************"
create_system $SYSTEM_NAME

# module properties


# default module properties


# Instances and instance parameters
# (disabled instances are intentionally culled)
add_instance clk_0 clock_source "$(TOOL_VER)"

set_instance_parameter_value clk_0 clockFrequency {50000000.0}
set_instance_parameter_value clk_0 clockFrequencyKnown {1}
set_instance_parameter_value clk_0 resetSynchronousEdges {BOTH}

add_instance CPU altera_nios2_qsys "$(TOOL_VER)"
	set_instance_parameter_value CPU {impl} "$cpu_impl"
	set_instance_parameter_value CPU {setting_showUnpublishedSettings} {1}
    set_instance_parameter_value CPU {setting_showInternalSettings} {1}
    set_instance_parameter_value CPU {setting_preciseSlaveAccessErrorException} {0}
    set_instance_parameter_value CPU {setting_preciseIllegalMemAccessException} {0}
    set_instance_parameter_value CPU {setting_preciseDivisionErrorException} {0}
    set_instance_parameter_value CPU {setting_performanceCounter} {0}
    set_instance_parameter_value CPU {setting_illegalMemAccessDetection} {0}
    set_instance_parameter_value CPU {setting_illegalInstructionsTrap} {0}
    set_instance_parameter_value CPU {setting_fullWaveformSignals} {0}
    set_instance_parameter_value CPU {setting_extraExceptionInfo} {0}
    set_instance_parameter_value CPU {setting_exportPCB} {0}
    set_instance_parameter_value CPU {setting_debugSimGen} {0}
    set_instance_parameter_value CPU {setting_clearXBitsLDNonBypass} {1}
    set_instance_parameter_value CPU {setting_bit31BypassDCache} {0}
    set_instance_parameter_value CPU {setting_bigEndian} {0}
    set_instance_parameter_value CPU {setting_export_large_RAMs} {0}
    set_instance_parameter_value CPU {setting_asic_enabled} {0}
    set_instance_parameter_value CPU {setting_asic_synopsys_translate_on_off} {0}
    set_instance_parameter_value CPU {setting_bhtIndexPcOnly} {0}
    set_instance_parameter_value CPU {setting_avalonDebugPortPresent} {0}
    set_instance_parameter_value CPU {setting_alwaysEncrypt} {1}
    set_instance_parameter_value CPU {setting_allowFullAddressRange} {0}
    set_instance_parameter_value CPU {setting_activateTrace} {1}
    set_instance_parameter_value CPU {setting_activateTrace_user} {0}
    set_instance_parameter_value CPU {setting_activateTestEndChecker} {0}
    set_instance_parameter_value CPU {setting_ecc_sim_test_ports} {0}
    set_instance_parameter_value CPU {setting_activateMonitors} {1}
    set_instance_parameter_value CPU {setting_activateModelChecker} {0}
    set_instance_parameter_value CPU {setting_HDLSimCachesCleared} {1}
    set_instance_parameter_value CPU {setting_HBreakTest} {0}
    set_instance_parameter_value CPU {setting_breakslaveoveride} {0}
    set_instance_parameter_value CPU {muldiv_divider} ${USE_DIV}
    set_instance_parameter_value CPU {mpu_useLimit} {0}
    set_instance_parameter_value CPU {mpu_enabled} {0}
    set_instance_parameter_value CPU {mmu_enabled} {0}
    set_instance_parameter_value CPU {mmu_autoAssignTlbPtrSz} {1}
    set_instance_parameter_value CPU {manuallyAssignCpuID} {1}
    set_instance_parameter_value CPU {dcache_omitDataMaster} {0}
    set_instance_parameter_value CPU {cpuReset} {0}
    set_instance_parameter_value CPU {resetrequest_enabled} {1}
    set_instance_parameter_value CPU {setting_removeRAMinit} {0}
    set_instance_parameter_value CPU {setting_shadowRegisterSets} {0}
    set_instance_parameter_value CPU {mpu_numOfInstRegion} {8}
    set_instance_parameter_value CPU {mpu_numOfDataRegion} {8}
    set_instance_parameter_value CPU {mmu_TLBMissExcOffset} {0}
    set_instance_parameter_value CPU {resetOffset} {0}
    set_instance_parameter_value CPU {exceptionOffset} {256}
    set_instance_parameter_value CPU {cpuID} {0}
    set_instance_parameter_value CPU {cpuID_stored} {0}
    set_instance_parameter_value CPU {breakOffset} {32}
    set_instance_parameter_value CPU {userDefinedSettings} {}
    set_instance_parameter_value CPU {resetSlave} {wb_intmem.avslave}
    set_instance_parameter_value CPU {mmu_TLBMissExcSlave} {None}
    set_instance_parameter_value CPU {exceptionSlave} {wb_extmem.avs}
    set_instance_parameter_value CPU {setting_perfCounterWidth} {32}
    set_instance_parameter_value CPU {setting_interruptControllerType} {Internal}
    set_instance_parameter_value CPU {setting_branchPredictionType} {Automatic}
    set_instance_parameter_value CPU {setting_bhtPtrSz} {8}
    set_instance_parameter_value CPU {mpu_minInstRegionSize} {12}
    set_instance_parameter_value CPU {mpu_minDataRegionSize} {12}
    set_instance_parameter_value CPU {mmu_uitlbNumEntries} {4}
    set_instance_parameter_value CPU {mmu_udtlbNumEntries} {6}
    set_instance_parameter_value CPU {mmu_tlbPtrSz} {7}
    set_instance_parameter_value CPU {mmu_tlbNumWays} {16}
    set_instance_parameter_value CPU {mmu_processIDNumBits} {8}
    set_instance_parameter_value CPU {setting_exportvectors} {0}
    set_instance_parameter_value CPU {setting_ecc_present} {0}
    set_instance_parameter_value CPU {setting_ic_ecc_present} {1}
    set_instance_parameter_value CPU {setting_rf_ecc_present} {1}
    set_instance_parameter_value CPU {setting_mmu_ecc_present} {1}
    set_instance_parameter_value CPU {setting_dc_ecc_present} {0}
    set_instance_parameter_value CPU {setting_itcm_ecc_present} {0}
    set_instance_parameter_value CPU {setting_dtcm_ecc_present} {0}
    set_instance_parameter_value CPU {regfile_ramBlockType} {Automatic}
    set_instance_parameter_value CPU {ocimem_ramBlockType} {Automatic}
    set_instance_parameter_value CPU {mmu_ramBlockType} {Automatic}
    set_instance_parameter_value CPU {bht_ramBlockType} {Automatic}

if {
	$USE_HW_MUL_IMPL == "dsp_mul"
} then {
	set_instance_parameter_value CPU {muldiv_multiplierType} {DSPBlock}
} else {
	set_instance_parameter_value CPU {muldiv_multiplierType} {NoneSmall}
	
}

# ********** Instruction Cache ****************
if {
	$USE_ICACHE == "1"
} then {
	set_instance_parameter_value CPU {icache_size} ${ICACHE_SIZE}
} else {
	set_instance_parameter_value CPU {icache_size} {0}
}
    set_instance_parameter_value CPU {icache_tagramBlockType} {Automatic}
    set_instance_parameter_value CPU {icache_ramBlockType} {Automatic}
    set_instance_parameter_value CPU {icache_numTCIM} {0}
    set_instance_parameter_value CPU {icache_burstType} {None}
# ************************ JTAG DEBUG ************************************
if { 
	$JTAG_MODULE_ENABLE=="Enable"
} then {
	if {
		$BREAKPOINT_ON_HREset == "Enable"
	} then {
		set_instance_parameter_value CPU {debug_level} {Level2}
	} else {
		set_instance_parameter_value CPU {debug_level} {Level1}
	}
	set_instance_parameter_value CPU {breakSlave} {CPU.jtag_debug_module}
	set_instance_parameter_value CPU {debug_jtagInstanceID} {0}
	set_instance_parameter_value CPU {debug_triggerArming} {1}
	set_instance_parameter_value CPU {debug_embeddedPLL} {1}
	set_instance_parameter_value CPU {debug_debugReqSignals} {0}
	set_instance_parameter_value CPU {debug_assignJtagInstanceID} {0}
	set_instance_parameter_value CPU {setting_oci_export_jtag_signals} {1}
	set_instance_parameter_value CPU {debug_OCIOnchipTrace} {_128}
} else {
	set_instance_parameter_value CPU {debug_level} {NoDebug}
	set_instance_parameter_value CPU {breakSlave} {wb_intmem.avslave}
}

# ********** Data Cache ****************
if {
	$USE_DCACHE == "1"
} then {
	set_instance_parameter_value CPU {dcache_size} ${DCACHE_SIZE}
} else {
	set_instance_parameter_value CPU {dcache_size} {0}
}
    set_instance_parameter_value CPU {dcache_bursts} {false}
    set_instance_parameter_value CPU {dcache_victim_buf_impl} {ram}
    set_instance_parameter_value CPU {dcache_tagramBlockType} {Automatic}
    set_instance_parameter_value CPU {dcache_ramBlockType} {Automatic}
    set_instance_parameter_value CPU {dcache_numTCDM} {0}
    set_instance_parameter_value CPU {dcache_lineSize} {32}

    add_instance wb_io tmpl_io 1.0

    add_instance wb_intmem tmpl_intmem 1.0

    add_instance wb_extmem tmpl_extmem 1.0

    add_instance wb_irq tmpl_interrupt 1.0

# connections and connection parameters
if {
	$JTAG_MODULE_ENABLE == "Enable"
} then {
    add_connection CPU.instruction_master CPU.jtag_debug_module avalon
    set_connection_parameter_value CPU.instruction_master/CPU.jtag_debug_module arbitrationPriority {1}
    set_connection_parameter_value CPU.instruction_master/CPU.jtag_debug_module baseAddress {0x00fff000}
    set_connection_parameter_value CPU.instruction_master/CPU.jtag_debug_module defaultConnection {0}

    add_connection CPU.data_master CPU.jtag_debug_module avalon
    set_connection_parameter_value CPU.data_master/CPU.jtag_debug_module arbitrationPriority {1}
    set_connection_parameter_value CPU.data_master/CPU.jtag_debug_module baseAddress {0x00fff000}
    set_connection_parameter_value CPU.data_master/CPU.jtag_debug_module defaultConnection {0}
}
 add_connection clk_0.clk CPU.clk clock

    add_connection clk_0.clk_reset CPU.reset_n reset

    add_connection CPU.data_master wb_io.avs avalon
    set_connection_parameter_value CPU.data_master/wb_io.avs arbitrationPriority {1}
    set_connection_parameter_value CPU.data_master/wb_io.avs baseAddress {0xff000000}
    set_connection_parameter_value CPU.data_master/wb_io.avs defaultConnection {0}

    add_connection CPU.instruction_master wb_io.avs avalon
    set_connection_parameter_value CPU.instruction_master/wb_io.avs arbitrationPriority {1}
    set_connection_parameter_value CPU.instruction_master/wb_io.avs baseAddress {0xff000000}
    set_connection_parameter_value CPU.instruction_master/wb_io.avs defaultConnection {0}

    add_connection clk_0.clk wb_extmem.clock_sink clock

    add_connection clk_0.clk wb_irq.clock_sink clock

    add_connection clk_0.clk_reset wb_irq.reset_sink reset

    add_connection clk_0.clk_reset wb_intmem.rst reset

    add_connection clk_0.clk wb_intmem.clk clock

    add_connection CPU.data_master wb_intmem.avslave avalon
    set_connection_parameter_value CPU.data_master/wb_intmem.avslave arbitrationPriority {1}
    set_connection_parameter_value CPU.data_master/wb_intmem.avslave baseAddress {0x0000}
    set_connection_parameter_value CPU.data_master/wb_intmem.avslave defaultConnection {0}

    add_connection CPU.instruction_master wb_intmem.avslave avalon
    set_connection_parameter_value CPU.instruction_master/wb_intmem.avslave arbitrationPriority {1}
    set_connection_parameter_value CPU.instruction_master/wb_intmem.avslave baseAddress {0x0000}
    set_connection_parameter_value CPU.instruction_master/wb_intmem.avslave defaultConnection {0}

    add_connection clk_0.clk_reset wb_extmem.reset_sink reset

    add_connection CPU.instruction_master wb_extmem.avs avalon
    set_connection_parameter_value CPU.instruction_master/wb_extmem.avs arbitrationPriority {1}
    set_connection_parameter_value CPU.instruction_master/wb_extmem.avs baseAddress {0x01000000}
    set_connection_parameter_value CPU.instruction_master/wb_extmem.avs defaultConnection {0}

    add_connection CPU.data_master wb_extmem.avs avalon
    set_connection_parameter_value CPU.data_master/wb_extmem.avs arbitrationPriority {1}
    set_connection_parameter_value CPU.data_master/wb_extmem.avs baseAddress {0x01000000}
    set_connection_parameter_value CPU.data_master/wb_extmem.avs defaultConnection {0}



    add_connection clk_0.clk_reset wb_io.reset_sink reset

    add_connection clk_0.clk wb_io.clock_sink clock

    add_connection CPU.d_irq wb_irq.irq_0_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_0_sender irqNumber {0}

    add_connection CPU.d_irq wb_irq.irq_1_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_1_sender irqNumber {1}

    add_connection CPU.d_irq wb_irq.irq_2_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_2_sender irqNumber {2}

    add_connection CPU.d_irq wb_irq.irq_3_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_3_sender irqNumber {3}

    add_connection CPU.d_irq wb_irq.irq_4_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_4_sender irqNumber {4}

    add_connection CPU.d_irq wb_irq.irq_5_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_5_sender irqNumber {5}

    add_connection CPU.d_irq wb_irq.irq_6_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_6_sender irqNumber {6}

    add_connection CPU.d_irq wb_irq.irq_7_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_7_sender irqNumber {7}

    add_connection CPU.d_irq wb_irq.irq_8_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_8_sender irqNumber {8}

    add_connection CPU.d_irq wb_irq.irq_9_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_9_sender irqNumber {9}

    add_connection CPU.d_irq wb_irq.irq_10_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_10_sender irqNumber {10}

    add_connection CPU.d_irq wb_irq.irq_11_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_11_sender irqNumber {11}

    add_connection CPU.d_irq wb_irq.irq_12_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_12_sender irqNumber {12}

    add_connection CPU.d_irq wb_irq.irq_13_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_13_sender irqNumber {13}

    add_connection CPU.d_irq wb_irq.irq_14_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_14_sender irqNumber {14}

    add_connection CPU.d_irq wb_irq.irq_15_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_15_sender irqNumber {15}

    add_connection CPU.d_irq wb_irq.irq_16_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_16_sender irqNumber {16}

    add_connection CPU.d_irq wb_irq.irq_17_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_17_sender irqNumber {17}

    add_connection CPU.d_irq wb_irq.irq_18_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_18_sender irqNumber {18}

    add_connection CPU.d_irq wb_irq.irq_19_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_19_sender irqNumber {19}

    add_connection CPU.d_irq wb_irq.irq_20_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_20_sender irqNumber {20}

    add_connection CPU.d_irq wb_irq.irq_21_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_21_sender irqNumber {21}

    add_connection CPU.d_irq wb_irq.irq_22_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_22_sender irqNumber {22}

    add_connection CPU.d_irq wb_irq.irq_23_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_23_sender irqNumber {23}

    add_connection CPU.d_irq wb_irq.irq_24_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_24_sender irqNumber {24}

    add_connection CPU.d_irq wb_irq.irq_25_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_25_sender irqNumber {25}

    add_connection CPU.d_irq wb_irq.irq_26_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_26_sender irqNumber {26}

    add_connection CPU.d_irq wb_irq.irq_27_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_27_sender irqNumber {27}

    add_connection CPU.d_irq wb_irq.irq_28_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_28_sender irqNumber {28}

    add_connection CPU.d_irq wb_irq.irq_29_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_29_sender irqNumber {29}

    add_connection CPU.d_irq wb_irq.irq_30_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_30_sender irqNumber {30}
	
	add_connection CPU.d_irq wb_irq.irq_31_sender interrupt
    set_connection_parameter_value CPU.d_irq/wb_irq.irq_31_sender irqNumber {31}



# exported interfaces
    add_interface clk clock sink
    set_interface_property clk EXPORT_OF clk_0.clk_in
    add_interface reset reset sink
    set_interface_property reset EXPORT_OF clk_0.clk_in_reset
    add_interface wb_irq_inp conduit end
    set_interface_property wb_irq_inp EXPORT_OF wb_irq.irq_inp_bus

if {
	$JTAG_MODULE_ENABLE == "Enable"
} then {
    add_interface sld_jtag conduit end
    set_interface_property sld_jtag EXPORT_OF CPU.sld_jtag_conduit
}
    add_interface wb_io_exp_data conduit end
    set_interface_property wb_io_exp_data EXPORT_OF wb_io.exp_data
    add_interface wb_io_exp_addr conduit end
    set_interface_property wb_io_exp_addr EXPORT_OF wb_io.exp_addr
    add_interface wb_io_exp_read conduit end
    set_interface_property wb_io_exp_read EXPORT_OF wb_io.exp_read
    add_interface wb_io_exp_write conduit end
    set_interface_property wb_io_exp_write EXPORT_OF wb_io.exp_write
    add_interface wb_io_exp_ack conduit end
    set_interface_property wb_io_exp_ack EXPORT_OF wb_io.exp_ack
    add_interface wb_io_exp_stb conduit end
    set_interface_property wb_io_exp_stb EXPORT_OF wb_io.exp_stb
    add_interface wb_io_exp_cyc conduit end
    set_interface_property wb_io_exp_cyc EXPORT_OF wb_io.exp_cyc
    add_interface wb_intmem_exp_addr conduit end
    set_interface_property wb_intmem_exp_addr EXPORT_OF wb_intmem.exp_addr
    add_interface wb_intmem_exp_read conduit end
    set_interface_property wb_intmem_exp_read EXPORT_OF wb_intmem.exp_read
    add_interface wb_intmem_exp_write conduit end
    set_interface_property wb_intmem_exp_write EXPORT_OF wb_intmem.exp_write
    add_interface wb_intmem_exp_ack conduit end
    set_interface_property wb_intmem_exp_ack EXPORT_OF wb_intmem.exp_ack
    add_interface wb_intmem_exp_stb conduit end
    set_interface_property wb_intmem_exp_stb EXPORT_OF wb_intmem.exp_stb
    add_interface wb_intmem_exp_cyc conduit end
    set_interface_property wb_intmem_exp_cyc EXPORT_OF wb_intmem.exp_cyc
    add_interface wb_intmem_exp_data conduit end
    set_interface_property wb_intmem_exp_data EXPORT_OF wb_intmem.exp_data
    add_interface wb_extmem_exp_data conduit end
    set_interface_property wb_extmem_exp_data EXPORT_OF wb_extmem.exp_data
    add_interface wb_extmem_exp_addr conduit end
    set_interface_property wb_extmem_exp_addr EXPORT_OF wb_extmem.exp_addr
    add_interface wb_extmem_exp_read conduit end
    set_interface_property wb_extmem_exp_read EXPORT_OF wb_extmem.exp_read
    add_interface wb_extmem_exp_write conduit end
    set_interface_property wb_extmem_exp_write EXPORT_OF wb_extmem.exp_write
    add_interface wb_extmem_exp_ack conduit end
    set_interface_property wb_extmem_exp_ack EXPORT_OF wb_extmem.exp_ack
    add_interface wb_extmem_exp_cyc conduit end
    set_interface_property wb_extmem_exp_cyc EXPORT_OF wb_extmem.exp_cyc
    add_interface wb_extmem_exp_stb conduit end
    set_interface_property wb_extmem_exp_stb EXPORT_OF wb_extmem.exp_stb

# interconnect requirements
    set_interconnect_requirement {$system} {qsys_mm.clockCrossingAdapter} {HANDSHAKE}
    set_interconnect_requirement {$system} {qsys_mm.maxAdditionalLatency} {1}
validate_system
#save_system $qsys_file_name
save_system $qsys_file_fullname

